%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Author: Rafael Philip LUDWIG, 2014
%%%% Contact: rafael.ludwig@student.tugraz.at
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function varargout = Noise_Level_Analyzer(varargin)

% Noise_Level_Analyzer M-file for Noise_Level_Analyzer.fig
%      Noise_Level_Analyzer, by itself, creates a new Noise_Level_Analyzer or raises the existing
%      singleton*.
%
%      H = Noise_Level_Analyzer returns the handle to a new Noise_Level_Analyzer or the handle to
%      the existing singleton*.
%
%      Noise_Level_Analyzer('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in Noise_Level_Analyzer.M with the given input arguments.
%
%      Noise_Level_Analyzer('Property','Value',...) creates a new Noise_Level_Analyzer or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the Noise_Level_Analyzer before Noise_Level_Analyzer_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      ed_stop.  All inputs are passed to Noise_Level_Analyzer_OpeningFcn via varargin.
%
%      *See Noise_Level_Analyzer Options on GUIDE's Tools menu.  Choose "Noise_Level_Analyzer allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Noise_Level_Analyzer

% Last Modified by GUIDE v2.5 29-May-2014 15:03:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Noise_Level_Analyzer_OpeningFcn, ...
                   'gui_OutputFcn',  @Noise_Level_Analyzer_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Noise_Level_Analyzer is made visible.
 function Noise_Level_Analyzer_OpeningFcn(hObject, ~, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Noise_Level_Analyzer (see VARARGIN)

handles.output = hObject;

%%%% LOGO einfgen
I=imread('logo.jpg');  % TU Graz Logo laden
axes(handles.axes_logo);    % 
imshow(I);             % anzeigen
axes(handles.axes1); 

%%%%%%%%%%%%%%%%%%
% Default Settings
%%%%%%%%%%%%%%%%%%

clc;

% Enable and disable push buttons
set(handles.pb_loadcal,'Enable','on');
set(handles.pb_execute,'Enable','off');
set(handles.pb_loadfile,'Enable','off');
set(handles.pb_export,'Enable','off');
set(handles.pb_store,'Enable','off');
set(handles.pb_Lp,'Enable','off');
set(handles.pb_hist,'Enable','off');
set(handles.pb_fft,'Enable','off');
set(handles.pb_play,'Enable','off');
set(handles.pb_pause,'Enable','off');
set(handles.pb_stop,'Enable','off');

% Disable popup menus
set(handles.pop_fcurve,'Enable','off');
set(handles.pop_timeav,'Enable','off');
set(handles.pop_fft,'Enable','off');

% Set default String Contents and Background Colors, disable edit texts
set(handles.ed_start,'Enable','off');
set(handles.ed_stop,'Enable','off');
set(handles.ed_start,'String','');
set(handles.ed_stop,'String','');
set(handles.ed_Leq,'String','');
set(handles.ed_L1,'String','');
set(handles.ed_L95,'String','');
set(handles.ed_TLeq,'String','Leq');
set(handles.ed_TL1,'String','L1');
set(handles.ed_TL95,'String','L95');
set(handles.ed_loadedcalfile,'String','');
set(handles.ed_loadedfile,'String','');
set(handles.ed_loadcontrol,'String','');
set(handles.ed_loadcontrol,'BackgroundColor','w');
set(handles.ed_selectplot,'String','');
set(handles.ed_selectplot,'BackgroundColor','w');

cla(handles.axes1,'reset');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Noise_Level_Analyzer wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Noise_Level_Analyzer_OutputFcn(~, ~, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function file_Callback(~, ~, ~)
% hObject    handle to file (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of file as text
%        str2double(get(hObject,'String')) returns contents of file as a double


% --- Executes during object creation, after setting all properties.
function file_CreateFcn(hObject, ~, ~)
% hObject    handle to file (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function calsig_Callback(~, ~, ~)
% hObject    handle to calsig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of calsig as text
%        str2double(get(hObject,'String')) returns contents of calsig as a double


% --- Executes during object creation, after setting all properties.
function calsig_CreateFcn(hObject, ~, ~)
% hObject    handle to calsig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_loadcal.
function pb_loadcal_Callback(~, ~, handles)
% hObject    handle to pb_loadcal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Load Calibration File, Convert it to mono if
% necessary and derive p0 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Set default String Contents and Background Colors  
set(handles.ed_loadcontrol,'BackgroundColor','w');
set(handles.ed_loadedcalfile,'String','');
set(handles.ed_loadedfile,'String','');
set(handles.ed_selectplot,'String','');
set(handles.ed_selectplot,'BackgroundColor','w');

% Enable and disable push buttons
set(handles.pb_execute,'Enable','off');
set(handles.pb_play,'Enable','off');
set(handles.pb_loadfile,'Enable','off');
set(handles.pb_stop,'Enable','off');
set(handles.pb_pause,'Enable','off');
set(handles.pb_export,'Enable','off');
set(handles.pb_store,'Enable','off');
set(handles.pb_Lp,'Enable','off');
set(handles.pb_hist,'Enable','off');
set(handles.pb_fft,'Enable','off');
set(handles.pb_loadcal,'Enable','off');

% Disable popup menus
set(handles.pop_fft,'Enable','off');

cla;

% Get entered Calibration Volume, 94 dB default
kvol = str2double(get(handles.ed_kvol,'String'));   

% Checking that calibraion volume is entered and error displaying if not,
% default 94 dB
kvolcheck = isnan(kvol);

if kvolcheck == 1
    errordlg('enter the volume of the calibration signal','Error');
    set(handles.ed_Leq,'String','Error');
    set(handles.ed_L1,'String','Error');
    set(handles.ed_L95,'String','Error');
    return
end

% Get file path of the calibration file
calibration = uigetfile('*.wav','Select the calibration file');

set(handles.ed_loadcontrol,'BackgroundColor','r');
set(handles.ed_loadcontrol,'String','Loading Calibration File...');
drawnow;

kin = wavread(calibration); % Load calibration file to Matlab

lencalibration = length(calibration); % Vector length of the calibration file
calibration = calibration(1:lencalibration-4); % Shorten the filename, the ending .wav is deleted

set(handles.ed_loadedcalfile,'String',calibration); % Display calibration file name in the GUI 

% Deriving p0
[p0] = analyze_calibration(kin,kvol);

% Store p0,kvol and kin in the workspace
assignin('base','p0',p0);
assignin('base','kvol',kvol);
assignin('base','kin',kin);

% Enable and disable the necessary push buttons and display that
% calibration file is loaded
set(handles.pb_loadfile,'Enable','on');
set(handles.pb_loadcal,'Enable','on');
set(handles.pb_Lp,'Enable','off');
set(handles.pb_hist,'Enable','off');
set(handles.pb_fft,'Enable','off');

set(handles.ed_kvol,'Enable','off');
set(handles.ed_loadcontrol,'String','Calibration File is Loaded');
set(handles.ed_loadcontrol,'BackgroundColor','g');


function ed_kvol_Callback(~, ~, ~)
% hObject    handle to ed_kvol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ed_kvol as text
%        str2double(get(hObject,'String')) returns contents of ed_kvol as a double


% --- Executes during object creation, after setting all properties.
function ed_kvol_CreateFcn(hObject, ~, ~)
% hObject    handle to ed_kvol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_execute.
function pb_execute_Callback(hObject, eventdata, handles)
% hObject    handle to pb_execute (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Time vector with format hh:mm:ss is generated,
% displayed at the XAxis, get optional entered start and stop time for the
% file analysis, get entered average time and frequency curve, create the
% name for the output variables in dependency of the selected frequency
% curve (i.e L(A)eq, L(B)eq, L(C)eq or Leq), call the function
% sound_pressure_level, which derives the sound pressure level distribution
% and display results in the GUI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Loading necessary variables from the workspace
p0 = evalin('base','p0');
x2 = evalin('base','x2');
lenx2 = evalin('base','lenx2');
fs = evalin('base','fs');

% Display that file is analyzed
set(handles.ed_loadcontrol,'String','Analyzing File...');
set(handles.ed_loadcontrol,'BackgroundColor','r');
drawnow;

% Disable certain edit texts, push buttons and popup menus  
set(handles.ed_start,'Enable','off');
set(handles.ed_stop,'Enable','off');
set(handles.ed_kvol,'Enable','off');
set(handles.ed_selectplot,'String','');
set(handles.ed_selectplot,'BackgroundColor','w');

set(handles.pb_loadcal,'Enable','off');
set(handles.pb_execute,'Enable','off');
set(handles.pb_loadfile,'Enable','off');
set(handles.pb_Lp,'Enable','off');
set(handles.pb_hist,'Enable','off');
set(handles.pb_fft,'Enable','off');
set(handles.pb_play,'Enable','off');
set(handles.pb_store,'Enable','off');
set(handles.pb_export,'Enable','off');

set(handles.pop_fcurve,'Enable','off');
set(handles.pop_timeav,'Enable','off');
set(handles.pop_fft,'Enable','off');
drawnow;

% Create the help variables for the time vector time_x_str in cell format
len_x_sec = fix(lenx2/fs);
time_x_sec = 0:len_x_sec;
time_x_min = time_x_sec/60;
time_x_h = time_x_min/60;
time_x_str = cell(size(time_x_sec));

% Create a vector time_x_str in the time format hh:mm:ss as a string
for i = 1:len_x_sec+1
    time_x_str(i) = cellstr(sprintf('%02.0f:%02.0f:%02.0f',time_x_h(i),fix(rem(time_x_min(i),60)),rem(time_x_sec(i),60)));     
end    

% Create default variables
start_samples = 0;
stop_samples = 0;
start_sec = 0;
stop_sec = 0;

% Choosing the time intervall
starttime = get(handles.ed_start,'String');
stoptime = get(handles.ed_stop,'String'); 

% Derive the entered start time in seconds and samples, Check if
% entered start time is valid
if isempty(starttime) == 0
    % Split entered start time in seconds 
    startint = regexp(starttime,'\:','split');
    start_sec = str2double(startint{1})*3600 + str2double(startint{2})*60 + str2double(startint{3}); % Derive time in seconds
    start_samples = start_sec*fs; % Derive the number of samples
    
    if start_samples > lenx2 % If entered time is larger than file length, time is set to file begin
        helpdlg('start time is larger than file duration and is set to 00:00:00','time intervall');
        start_samples = 1;
        start_sec = 1;
        set(handles.ed_start,'String',char(time_x_str(1)));
        starttime = ''; % Clear String, otherwise the wrong start time will be exported later
    end
end

% Derive the entered stop time in seconds and samples, Check if
% entered stop time is valid
if isempty(stoptime) == 0
    % Split entered stop time in seconds
    stopint = regexp(stoptime,'\:','split');
    stop_sec = str2double(stopint{1})*3600 + str2double(stopint{2})*60 + str2double(stopint{3}); % Derive time in seconds 
    stop_samples = stop_sec*fs; % Derive the number of samples
    
    if stop_samples > lenx2 % If entered time is larger than file length, time is set to maximum file length
        helpdlg('stop time is larger than file duration and is set to maximum file length','time intervall');
        stop_samples = lenx2;
        stop_sec = fix(stop_samples/fs);
        set(handles.ed_stop,'String',char(time_x_str(length(time_x_str))));
        stoptime = ''; % Clear String, otherwise the wrong stop time will be exported later
    end
end

% If enentered start time is larger than stop time, both values are
% switched 
if ((isempty(starttime) == 0) && (isempty(stoptime) == 0) && (start_samples > stop_samples))
    helpdlg('start time is larger than stop time and both will be switched','time intervall');
    start_samples_help = start_samples;
    stop_samples_help = stop_samples;
    start_samples = stop_samples_help;
    stop_samples = start_samples_help;
    start_sec = fix(start_samples/fs);
    stop_sec = fix(stop_samples/fs);
    starttime_help = starttime;
    stoptime_help = stoptime;
    starttime = stoptime_help;
    stoptime = starttime_help;
    set(handles.ed_start,'String',starttime);
    set(handles.ed_stop,'String',stoptime);
end    

% Loading the selected frequency weighting curve from the GUI
dBweightval = get(handles.pop_fcurve,'Value');

% Choosing the selected frequency weighting curve (dB(A),dB(B),dB(C) or
% zero), giving the displayed parameters the correct name depending on the
% chosen frequency curve
if dBweightval == 1
    dBweight = 'dB(A)';
    text_Leq = 'L(A)eq';
    text_L1 = 'L(A)1';
    text_L95 = 'L(A)95';
elseif dBweightval == 2
    dBweight = 'dB(B)';
    text_Leq = 'L(B)eq';
    text_L1 = 'L(B)1';
    text_L95 = 'L(B)95';
elseif dBweightval == 3
    dBweight = 'dB(C)';
    text_Leq = 'L(C)eq';
    text_L1 = 'L(C)1';
    text_L95 = 'L(C)95';
else 
    dBweight = 'flat';
    text_Leq = 'Leq';
    text_L1 = 'L1';
    text_L95 = 'L95';
end

% Loading the selected time averaging constant from the GUI
avmodeval = get(handles.pop_timeav,'Value');
 
% Choosing the selected time average constant (fast, slow or impulse)
if avmodeval == 1
    avmode = 'fast';
elseif avmodeval == 2
    avmode = 'slow';
else 
    avmode = 'impulse';
end

% Calling the analyzing function sound_ressure_level
[Lp,Leq,L1,L95] = sound_pressure_level(x2,fs,p0,dBweight,avmode,start_samples,stop_samples);

% Returning the output parameters to the Noise_Level_Analyzer
set(handles.ed_Leq,'String',Leq);
set(handles.ed_L1,'String',L1);
set(handles.ed_L95,'String',L95);
set(handles.ed_TLeq,'String',text_Leq);
set(handles.ed_TL1,'String',text_L1);
set(handles.ed_TL95,'String',text_L95);

plot(handles.axes1,Lp);

set(handles.axes1,'XTick',0:fix(length(Lp)/15):length(Lp)); % 15 time samples are displayed at the bottom of the XAxis

% According to the possibly entered start and stop times in the GUI, the
% XTickLabel is subscribed 
if ((isempty(starttime) == 0) && (isempty(stoptime) == 0)) % START AND STOP time are entered
    set(handles.axes1,'XTickLabel',time_x_str(fix(start_sec+1:(stop_sec-start_sec)/15:stop_sec+1)));
elseif ((isempty(starttime) == 0) && (isempty(stoptime) == 1)) % ONLY START time is entered
    set(handles.axes1,'XTickLabel',time_x_str(fix(start_sec+1:(len_x_sec-start_sec)/15:len_x_sec+1)));
elseif ((isempty(starttime) == 1) && (isempty(stoptime) == 0)) % ONLY STOP time is entered
    set(handles.axes1,'XTickLabel',time_x_str(fix(1:stop_sec/15:stop_sec+1)));
else % No time intervall is chosen    
    set(handles.axes1,'XTickLabel',time_x_str(fix(1:len_x_sec/15:len_x_sec+1))); % Choose the right time values to be displayed at the bottom of the XAxis, intervall = 15
end

set(gca, 'YGrid', 'on');
set(gca, 'XGrid', 'on');
set(gca,'Fontsize',10);
title('Time-dependent Sound Pressure Level ');
xlabel('time [hh:mm:ss]');
ylabel('Lp [dB]');

selected_plot = 'Lp'; % Variable for the title when exporting figure as .jpeg
fftcalc = 0; % default variable for calculating fft, default = 0, means that no fft of the current analyzed signal was made

% Store the output parameters in the workspace
assignin('base','starttime',starttime);
assignin('base','stoptime',stoptime);
assignin('base','dBweightval',dBweightval);
assignin('base','dBweight',dBweight);
assignin('base','avmodeval',avmodeval);
assignin('base','avmode',avmode);
assignin('base','Lp',Lp);
assignin('base','L1',L1); 
assignin('base','L95',L95);
assignin('base','Leq',Leq);
assignin('base','time_x_str',time_x_str);
assignin('base','start_sec',start_sec);
assignin('base','stop_sec',stop_sec);
assignin('base','len_x_sec',len_x_sec);
assignin('base','selected_plot',selected_plot);
assignin('base','fftcalc',fftcalc);

% Set edit text contents, change their Background Colors
set(handles.ed_loadcontrol,'String','File is Analyzed');
set(handles.ed_loadcontrol,'BackgroundColor','g');
set(handles.ed_start,'Enable','on');
set(handles.ed_stop,'Enable','on');
set(handles.ed_start,'BackgroundColor','y');
set(handles.ed_stop,'BackgroundColor','y');
set(handles.ed_kvol,'Enable','on');

% Enable and disable certain necessary push buttons
set(handles.pb_play,'Enable','on');
set(handles.pb_stop,'Enable','off');
set(handles.pb_loadcal,'Enable','on');
set(handles.pb_execute,'Enable','on');
set(handles.pb_loadfile,'Enable','on');
set(handles.pb_export,'Enable','on');
set(handles.pb_store,'Enable','on');
set(handles.pb_Lp,'Enable','off');
set(handles.pb_hist,'Enable','on');
set(handles.pb_fft,'Enable','on');

% Enable popup menus
set(handles.pop_fcurve,'Enable','on');
set(handles.pop_timeav,'Enable','on');
set(handles.pop_fft,'Enable','on');


% --- Executes on selection change in pop_fcurve.
function pop_fcurve_Callback(~, ~, ~)
% hObject    handle to pop_fcurve (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns pop_fcurve contents as cell array
%        contents{get(hObject,'Value')} returns selected item from pop_fcurve


% --- Executes during object creation, after setting all properties.
function pop_fcurve_CreateFcn(hObject, ~, ~)
% hObject    handle to pop_fcurve (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in timeavtxt.
function pop_timeav_Callback(~, ~, ~)
% hObject    handle to timeavtxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns timeavtxt contents as cell array
%        contents{get(hObject,'Value')} returns selected item from timeavtxt


% --- Executes during object creation, after setting all properties.
function timeavtxt_CreateFcn(hObject, ~, ~)
% hObject    handle to timeavtxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function ed_start_Callback(~, ~, ~)
% hObject    handle to ed_start (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ed_start as text
%        str2double(get(hObject,'String')) returns contents of ed_start as a double


% --- Executes during object creation, after setting all properties.
function ed_start_CreateFcn(hObject, ~, ~)
% hObject    handle to ed_start (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function ed_stop_Callback(~, ~, ~)
% hObject    handle to ed_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ed_stop as text
%        str2double(get(hObject,'String')) returns contents of ed_stop as a double


% --- Executes during object creation, after setting all properties.
function ed_stop_CreateFcn(hObject, ~, ~)
% hObject    handle to ed_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_loadfile.
function pb_loadfile_Callback(~, ~, handles)
% hObject    handle to pb_loadfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Load the input file to be analyzed and call
% function convert_file_to_mono to check if mono conversion is necessary
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Enable or Disable the push buttons, set default BackgroundColors, set
% default String contents
set(handles.ed_loadcontrol,'BackgroundColor','w');
set(handles.ed_loadcontrol,'String','');
set(handles.ed_loadedfile,'String','');
set(handles.ed_start,'String','');
set(handles.ed_start,'BackgroundColor','y');
set(handles.ed_stop,'String','');
set(handles.ed_stop,'BackgroundColor','y');
set(handles.ed_selectplot,'String','');
set(handles.ed_selectplot,'BackgroundColor','w');

set(handles.pb_play,'Enable','off');
set(handles.pb_stop,'Enable','off');
set(handles.pb_pause,'Enable','off');
set(handles.pb_export,'Enable','off');
set(handles.pb_store,'Enable','off');
set(handles.pb_Lp,'Enable','off');
set(handles.pb_hist,'Enable','off');
set(handles.pb_fft,'Enable','off');
set(handles.pb_loadfile,'Enable','off');
set(handles.pb_loadcal,'Enable','off');
set(handles.pb_execute,'Enable','off');

set(handles.pop_fft,'Enable','off');

cla;

% Get the file path
input = uigetfile('*.wav','Select the file to be analyzed');

display('Loading File');
set(handles.ed_loadcontrol,'String','Loading File...');
set(handles.ed_loadcontrol,'BackgroundColor','r');
drawnow;

% Load input file to Matlab
[x1,fs] = wavread(input);

leninput = length(input); % Length of the input file
input = input(1:leninput-4); % Shorten the name of the input file, the ending .wav is deleted

[x2] = convert_file_to_mono(x1);

clear x1;
assignin('base','x1',0);

lenx2 = length(x2);

% Create a text file to which analyzed data will be exported later
fid = fopen([input ' Dokumentation.txt'],'w'); 
fprintf(fid,'%s\r\n',input);
fclose(fid);

assignin('base','input',input);
assignin('base','fs',fs);
assignin('base','x2',x2);
assignin('base','lenx2',lenx2);

% Enable and disable necessary push buttons, and edit texts
set(handles.pb_execute,'Enable','on');
set(handles.pop_fcurve,'Enable','on');
set(handles.pop_timeav,'Enable','on');
set(handles.pb_Lp,'Enable','off');
set(handles.pb_hist,'Enable','off');
set(handles.pb_fft,'Enable','off');
set(handles.ed_start,'Enable','on');
set(handles.ed_stop,'Enable','on');
set(handles.ed_kvol,'Enable','off');
set(handles.pb_loadfile,'Enable','on');
set(handles.pb_loadcal,'Enable','on');

% Display that input file is loaded
set(handles.ed_loadedfile,'String',input);
set(handles.ed_loadcontrol,'String','File is Loaded');
set(handles.ed_loadcontrol,'BackgroundColor','g');
display('File is loaded');


% --- Executes during object creation, after setting all properties.
function pop_timeav_CreateFcn(hObject, ~, ~)
% hObject    handle to pop_timeav (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function ed_loadedcalfile_Callback(~, ~, ~)
% hObject    handle to ed_loadedcalfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ed_loadedcalfile as text
%        str2double(get(hObject,'String')) returns contents of ed_loadedcalfile as a double


% --- Executes during object creation, after setting all properties.
function ed_loadedcalfile_CreateFcn(hObject, ~, ~)
% hObject    handle to ed_loadedcalfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function ed_loadedfile_Callback(~, ~, ~)
% hObject    handle to ed_loadedfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ed_loadedfile as text
%        str2double(get(hObject,'String')) returns contents of ed_loadedfile as a double


% --- Executes during object creation, after setting all properties.
function ed_loadedfile_CreateFcn(hObject, ~, ~)
% hObject    handle to ed_loadedfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_play.
function pb_play_Callback(~, ~, handles)
% hObject    handle to pb_play (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Start the audio player and play the frequeny
% weighted input signal
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Start Audio Player
player = evalin('base','player');
play(player);
playing = 1; % Playing = 1 means that player is running 
set(handles.pb_pause,'Enable','On');
set(handles.pb_stop,'Enable','On');
assignin('base','playing',playing);


% --- Executes on button press in pb_stop.
function pb_stop_Callback(~, ~, handles)
% hObject    handle to pb_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: stop audio player
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Terminate Audio Player
player = evalin('base','player');
stop(player);

set(handles.pb_stop,'Enable','Off');
set(handles.pb_pause,'Enable','off');


function ed_loadcontrol_Callback(~, ~, ~)
% hObject    handle to ed_loadcontrol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ed_loadcontrol as text
%        str2double(get(hObject,'String')) returns contents of ed_loadcontrol as a double


% --- Executes during object creation, after setting all properties.
function ed_loadcontrol_CreateFcn(hObject, ~, ~)
% hObject    handle to ed_loadcontrol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_pause.
function pb_pause_Callback(~, ~, ~)
% hObject    handle to pb_pause (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: pause audioplayer
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Pause audioplayer
playing = evalin('base','playing');
player = evalin('base','player');

if playing == 1 % Player is running
    pause(player);
    playing = 0;
    assignin('base','playing',playing);
else % Player is paused
    resume(player);
    playing = 1; % Player is running again
    assignin('base','playing',playing);
    
end;


% --- Executes on button press in pb_export.
function pb_export_Callback(~, ~, handles)
% hObject    handle to pb_export (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: export the level statistics to a text file, if
% file was analyzed several times, each result is attached at the end of
% the text file, analysis options according to the respective analysis 
% are stored too
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set(handles.pb_export,'Enable','off');

avmode = evalin('base','avmode');
dBweight = evalin('base','dBweight');
starttime = evalin('base','starttime');
stoptime = evalin('base','stoptime');
time_x_str = evalin('base','time_x_str');
input = evalin('base','input');

% Get parameters to be stored in the .txt file from the workspace
L0_1 = num2str(evalin('base','L0_1'));
L1 = num2str(evalin('base','L1'));
L10 = num2str(evalin('base','L10'));
L33_3 = num2str(evalin('base','L33_3'));
L50 = num2str(evalin('base','L50'));
L66_6 = num2str(evalin('base','L66_6'));
L90 = num2str(evalin('base','L90'));
L95 = num2str(evalin('base','L95'));
L99 = num2str(evalin('base','L99'));
L99_9 = num2str(evalin('base','L99_9'));
Leq = num2str(evalin('base','Leq'));

len_time_x_str = length(time_x_str);

% Check if start time is entered in the GUI
if isempty(starttime) == 1
    starttime = cell2mat(time_x_str(1));
end

% Check if stop time is entered in the GUI
if isempty(stoptime) == 1
    stoptime = cell2mat(time_x_str(len_time_x_str));
end

%  give names to the exported variables in dependency of the selected frequency weighting curve
if strcmp(dBweight,'dB(A)') == 1    
    text_Leq = 'L(A)eq';
    text_L0_1 = 'L(A)0.1';
    text_L1 = 'L(A)1.0';
    text_L10 = 'L(A)10.0';
    text_L33_3 = 'L(A)33.3';
    text_L50 = 'L(A)50.0';
    text_L66_6 = 'L(A)66.6';
    text_L90 = 'L(A)90.0';
    text_L95 = 'L(A)95.0';
    text_L99 = 'L(A)99.0';
    text_L99_9 = 'L(A)99.9';
    
elseif strcmp(dBweight,'dB(B)') == 1    
    text_Leq = 'L(B)eq';
    text_L0_1 = 'L(B)0.1';
    text_L1 = 'L(B)1.0';
    text_L10 = 'L(B)10.0';
    text_L33_3 = 'L(B)33.3';
    text_L50 = 'L(B)50.0';
    text_L66_6 = 'L(B)66.6';
    text_L90 = 'L(B)90.0';
    text_L95 = 'L(B)95.0';
    text_L99 = 'L(B)99.0';
    text_L99_9 = 'L(B)99.9';
    
elseif strcmp(dBweight,'dB(C)') == 1    
    text_Leq = 'L(C)eq';
    text_L0_1 = 'L(C)0.1';
    text_L1 = 'L(C)1.0';
    text_L10 = 'L(C)10.0';
    text_L33_3 = 'L(C)33.3';
    text_L50 = 'L(C)50.0';
    text_L66_6 = 'L(C)66.6';
    text_L90 = 'L(C)90.0';
    text_L95 = 'L(C)95.0';
    text_L99 = 'L(C)99.0';
    text_L99_9 = 'L(C)99.9';
    
else 
    text_Leq = 'Leq';
    text_L0_1 = 'L0.1';
    text_L1 = 'L1.0';
    text_L10 = 'L10.0';
    text_L33_3 = 'L33.3';
    text_L50 = 'L50.0';
    text_L66_6 = 'L66.6';
    text_L90 = 'L90.0';
    text_L95 = 'L95.0';
    text_L99 = 'L99.0';
    text_L99_9 = 'L99.9';
end

% Write the content to be exported as text file in one string
export_content{1} = '';
export_content{2} = ['Frequency weighting curve: ' dBweight ];
export_content{3} = ['Average time constant: ' avmode ];
export_content{4} = ['Start time: ' starttime ];
export_content{5} = ['Stop time: ' stoptime ];
export_content{6} = [text_Leq ': ' Leq ' dB'];
export_content{7} = '';
export_content{8} = [text_L0_1 ': ' L0_1 ' dB'];
export_content{9} = [text_L1 ': ' L1  ' dB'];
export_content{10} = [text_L10 ': ' L10 ' dB'];
export_content{11} = [text_L33_3 ': ' L33_3 ' dB'];
export_content{12} = [text_L50 ': ' L50 ' dB'];
export_content{13} = [text_L66_6 ': ' L66_6 ' dB'];
export_content{14} = [text_L90 ': ' L90 ' dB'];
export_content{15} = [text_L95 ': ' L95 ' dB'];
export_content{16} = [text_L99 ': ' L99 ' dB'];
export_content{17} = [text_L99_9 ': ' L99_9 ' dB'];
export_content{18} = '';

% Store the String content in a text file
fid = fopen([input ' Dokumentation.txt'],'a'); 
fprintf(fid,'%s\r\n',export_content{:});
fclose(fid);

set(handles.pb_export,'Enable','on');


% --- Executes on button press in pb_Lp.
function pb_Lp_Callback(~, ~, handles)
% hObject    handle to pb_Lp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Plot time dependent sound pressure level
% distribution if the FFT or the Histogram was plotted before
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set(handles.pb_store,'Enable','off');
set(handles.pb_play,'Enable','off');
set(handles.pb_export,'Enable','off');
set(handles.pb_loadcal,'Enable','off');
set(handles.pb_loadfile,'Enable','off');
set(handles.pb_execute,'Enable','off');
set(handles.pb_fft,'Enable','off');
set(handles.pb_hist,'Enable','off');
set(handles.pb_Lp,'Enable','off');


Lp = evalin('base','Lp');
starttime = evalin('base','starttime');
stoptime = evalin('base','stoptime');
time_x_str = evalin('base','time_x_str');
start_sec = evalin('base','start_sec');
stop_sec = evalin('base','stop_sec');
len_x_sec = evalin('base','len_x_sec');

set(handles.ed_selectplot,'String','Calculating SPL...');
set(handles.ed_selectplot,'BackgroundColor','r');
drawnow;


cla;

plot(handles.axes1,Lp); % Plot the time dependent sound pressure level


set(handles.axes1,'XTick',0:fix(length(Lp)/15):length(Lp)); % 15 time samples are displayed at the bottom of the XAxis

% According to the possibly entered start and stop times in the GUI, the
% XTickLabel is subscribed 
if ((isempty(starttime) == 0) && (isempty(stoptime) == 0)) % START AND STOP time are entered
    set(handles.axes1,'XTickLabel',time_x_str(fix(start_sec+1:(stop_sec-start_sec)/15:stop_sec+1)));
elseif ((isempty(starttime) == 0) && (isempty(stoptime) == 1)) % ONLY START time is entered
    set(handles.axes1,'XTickLabel',time_x_str(fix(start_sec+1:(len_x_sec-start_sec)/15:len_x_sec+1)));
elseif ((isempty(starttime) == 1) && (isempty(stoptime) == 0)) % ONLY STOP time is entered
    set(handles.axes1,'XTickLabel',time_x_str(fix(1:stop_sec/15:stop_sec+1)));
else % No time intervall is chosen    
    set(handles.axes1,'XTickLabel',time_x_str(fix(1:len_x_sec/15:len_x_sec+1))); % Choose the right time values to be displayed at the bottom of the XAxis, intervall = 15
end

set(gca,'Fontsize',10);
set(gca, 'YGrid', 'on');
set(gca, 'XGrid', 'on');
title('Time-dependent Sound Pressure Level ');
xlabel('time [hh:mm:ss]');
ylabel('Lp [dB]');

selected_plot = 'Lp'; % Variable for the title when exporting figure as .jpeg

set(handles.ed_selectplot,'String','Finished');
set(handles.ed_selectplot,'BackgroundColor','g');
drawnow;

set(handles.pb_hist,'Enable','on');
set(handles.pb_fft,'Enable','on');
set(handles.pb_store,'Enable','on');
set(handles.pb_play,'Enable','on');
set(handles.pb_export,'Enable','on');
set(handles.pb_loadcal,'Enable','on');
set(handles.pb_loadfile,'Enable','on');
set(handles.pb_execute,'Enable','on');


assignin('base','selected_plot',selected_plot);


% --- Executes on button press in pb_hist.
function pb_hist_Callback(~, ~, handles)
% hObject    handle to pb_hist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Calculate the Histogram of the time dependent sound
% pressure level and plot it in the GUI with the cumulative sum
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set(handles.pb_store,'Enable','off');
set(handles.pb_play,'Enable','off');
set(handles.pb_export,'Enable','off');
set(handles.pb_loadcal,'Enable','off');
set(handles.pb_loadfile,'Enable','off');
set(handles.pb_execute,'Enable','off');
set(handles.pb_fft,'Enable','off');
set(handles.pb_hist,'Enable','off');
set(handles.pb_Lp,'Enable','off');

Lp = evalin('base','Lp');
lenhistogram = evalin('base','lenhistogram');

set(handles.ed_selectplot,'String','Calculating Histogram...');
set(handles.ed_selectplot,'BackgroundColor','r');
drawnow;

cla;

histogram = hist(Lp,lenhistogram); % Derive the histogram of the sound pressure level
histogram = histogram/sum(histogram); % Normalize the histogram, the sum of the histogram is equal 1

% Calculate the cumulative sum of the histogram and normalize it according
% to the histogram
cums = cumsum(histogram);
cums = cums*max(histogram);
cums = cums/max(cums);

[hAxes,~,hLine] = plotyy(handles.axes1,lenhistogram,histogram,lenhistogram,cums,'bar','plot');
set(hLine,'LineWidth',2,'Color','b');
colormap([0 0 0]);
set(gca,'Fontsize',10);

title('Histogram of the Sound Pressure Level Distribution');
xlabel('Sound Pressure Level [dB]');
ylabel(hAxes(1),'Probability of Occurence [%]')
ylabel(hAxes(2),'Cumulative Sum [%]')

set(hAxes(1), 'YTickMode', 'auto');
y1Beschriftung = get(hAxes(1), 'YTick');
set(hAxes(1), 'YTickLabel', [num2str(y1Beschriftung'*100)]);
set(hAxes(2), 'YTickMode', 'auto');
y2Beschriftung = get(hAxes(2), 'YTick');
set(hAxes(2), 'YTickLabel', [num2str(y2Beschriftung'*100)]);
set(hAxes(1), 'YGrid', 'on');
set(hAxes(1), 'XGrid', 'on');

selected_plot = 'Histogram'; % Variable for the title when exporting figure as .jpeg

set(handles.ed_selectplot,'String','Finished');
set(handles.ed_selectplot,'BackgroundColor','g');
drawnow;

set(handles.pb_Lp,'Enable','on');
set(handles.pb_fft,'Enable','on');
set(handles.pb_store,'Enable','on');
set(handles.pb_play,'Enable','on');
set(handles.pb_export,'Enable','on');
set(handles.pb_loadcal,'Enable','on');
set(handles.pb_loadfile,'Enable','on');
set(handles.pb_execute,'Enable','on');

assignin('base','selected_plot',selected_plot);


% --- Executes on button press in pb_fft.
function pb_fft_Callback(~, ~, handles)
% hObject    handle to pb_fft (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Calculate and plot FFT of the whole loaded input 
% file in dependency of the selected frequency curve, octave band, third 
% band, or 1/12 octave band analysis can be selected
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set(handles.pb_store,'Enable','off');
set(handles.pb_play,'Enable','off');
set(handles.pb_export,'Enable','off');
set(handles.pb_loadcal,'Enable','off');
set(handles.pb_loadfile,'Enable','off');
set(handles.pb_execute,'Enable','off');
set(handles.pb_fft,'Enable','off');
set(handles.pb_hist,'Enable','off');
set(handles.pb_Lp,'Enable','off');


xweight = evalin('base','xweight');
fs = evalin('base','fs');
fftopt = get(handles.pop_fft,'Value');
fftcalc = evalin('base','fftcalc');

set(handles.ed_selectplot,'String','Calculating FFT...');
set(handles.ed_selectplot,'BackgroundColor','r');
drawnow;

cla;

% Calling fft_Analysis for calculating either 1/1, 1/3 or 1/12 octave band
% analysis
[spect,freq] = fft_analysis(xweight,fs,fftopt,fftcalc);

% Plot single-sided amplitude spectrum. 
bar(handles.axes1,spect);
colormap([0 0 1]);

set(gca, 'YTickMode', 'auto');
yBeschriftung = get(gca, 'YTick');
set(gca, 'YTickLabel', [num2str(yBeschriftung'*100)]);

set(gca, 'YGrid', 'on');
set(gca, 'XGrid', 'on');
set(gca,'XTick',1:length(spect));
set(gca,'XTickLabel',{freq});
set(gca,'Fontsize',8);

drawnow;

title('Single-Sided Amplitude Spectrum');
xlabel('Frequency [Hz]');
ylabel('|X(f)| [%]');

selected_plot = 'FFT'; % Variable for the title when exporting figure as .jpeg

set(handles.ed_selectplot,'String','Finished');
set(handles.ed_selectplot,'BackgroundColor','g');
drawnow;

set(handles.pb_Lp,'Enable','on');
set(handles.pb_hist,'Enable','on');
set(handles.pb_store,'Enable','on');
set(handles.pb_play,'Enable','on');
set(handles.pb_export,'Enable','on');
set(handles.pb_loadcal,'Enable','on');
set(handles.pb_loadfile,'Enable','on');
set(handles.pb_execute,'Enable','on');

assignin('base','selected_plot',selected_plot);


% --- Executes on selection change in pop_fft.
function pop_fft_Callback(hObject, eventdata, handles)
% hObject    handle to pop_fft (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns pop_fft contents as cell array
%        contents{get(hObject,'Value')} returns selected item from pop_fft
pb_fft_Callback(hObject, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function pop_fft_CreateFcn(hObject, ~, ~)
% hObject    handle to pop_fft (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function ed_selectplot_Callback(~, ~, ~)
% hObject    handle to ed_selectplot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ed_selectplot as text
%        str2double(get(hObject,'String')) returns contents of ed_selectplot as a double


% --- Executes during object creation, after setting all properties.
function ed_selectplot_CreateFcn(hObject, ~, ~)
% hObject    handle to ed_selectplot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_store.
function pb_store_Callback(~, ~, handles)
% hObject    handle to pb_store (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Store current surface of the GUI as jpeg-file,
% selected plot and analysis options are attached to the file name
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set(handles.pb_store,'Enable','off');

selected_plot = num2str(evalin('base','selected_plot'));
input = evalin('base','input');
avmode = evalin('base','avmode');
dBweight = evalin('base','dBweight');
starttime = evalin('base','starttime');
stoptime = evalin('base','stoptime');
time_x_str = evalin('base','time_x_str');

len_time_x_str = length(time_x_str);

% Check if start time is entered in the GUI
if isempty(starttime) == 1
    starttime = cell2mat(time_x_str(1));
end

% Check if stop time is entered in the GUI
if isempty(stoptime) == 1
    stoptime = cell2mat(time_x_str(len_time_x_str));
end

% delete the ':' from the time string, so that it can be added to the name
% of the exported jpeg-figure
for i = 1:length(starttime)
    if starttime(i) == ':'
        starttime(i) = ' ';
    end
end

% delete the ':' from the time string, so that it can be added to the name
% of the exported jpeg-figure
for i = 1:length(stoptime)
    if stoptime(i) == ':'
        stoptime(i) = ' ';
    end
end

% Exporting figure as .jpeg file
fft_sel = ''; % Default Variable if no fft is plotted, but either histogram or SPL 

if strcmpi(selected_plot,'FFT') == 1 % Check if FFT is plotted
    
    selected_fft = get(handles.pop_fft,'Value'); % Check if octave band, third octave band fft or 1/12 octave band analysis is selected, 1 == octave band, 2 == third octave band 3 == 1/12 octave band analysis
    
    if selected_fft == 1
        fft_sel = 'Octave Band '; % Set String content for correct title for the .jpeg file 
    elseif selected_fft == 2
        fft_sel = 'Third Octave Band '; % Set String content for correct title for the .jpeg file
    else 
        fft_sel = 'Twelfth Octave Band '; % Set String content for correct title for the .jpeg file
    end
end

title = [(input) ' ' fft_sel selected_plot ' ' dBweight ' ' avmode ' ' char(starttime) ' - ' char(stoptime)];
hgexport(gcf, title, hgexport('factorystyle'), 'Format', 'jpeg'); % Export figure with correct title as .jpeg file

set(handles.pb_store,'Enable','on');
