function [p0] = analyze_calibration(kin,kvol)
%INPUTS:
% kin... RMS Value of the calibration signal
% kvol... Entered Reference Volume of calibrtaion
%
%OUTPUT:
% p0... Reference Sound Pressure Level 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Author: Rafael Philip LUDWIG, 2014
%%%% Contact: rafael.ludwig@student.tugraz.at
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: File is converted to mono if necessary, after that
% p0 is derived via calibration files' RMS-Value keff and the entered 
% calibration volume kvol
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Convert file to a mono file if it is not already mono
[k] = convert_file_to_mono(kin);

clear kin;

klen = length(k); % Length of calibration signal

keff = sqrt((1/klen)*sum(k.^2)); % RMS value of the calibration value

clear k;

% Derive p0
p0 = keff/(10^(kvol/20));

end