function [x2] = convert_file_to_mono(x1)
%INPUTS:
% x1... Loaded wave File
%
%OUTPUTS:
% x2... To mono converted file

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Author: Rafael Philip LUDWIG, 2014
%%%% Contact: rafael.ludwig@student.tugraz.at
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Stereo input files are converted to mono by
% respecting only the left channel
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dimx1 = size(x1); % Dimensions of the input signal

if dimx1 > 1 % Signal is stereo file
    x2 = x1(:,1); % Respect only left channel
else % Signal is mono file, vector content is copied
    x2 = x1; 
end

end