function [x3] = time_intervall(x2,lenx2,start_samples,stop_samples)
%INPUTS:
% x2... signal to be analyzed
% lenx2 ... length of the signal to be analyzed 
% start_samples... start position of the analysis, entered in the GUI
% stop_samples... stop position of the analysis, entered in the GUI
%
%OUTPUTS:
% x... shortened input signal, only signal part that shall be analyzed

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Author: Rafael Philip LUDWIG, 2014
%%%% Contact: rafael.ludwig@student.tugraz.at
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description: Select signal part for the analysis  if a start 
% or/and a stop position was enetered in the GUI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if ((start_samples ~= 0) && (stop_samples ~= 0)) % START AND STOP time are entered    
    x3 = x2(start_samples:stop_samples-1); % Store selected file sequence in a new vector x   
    
elseif ((start_samples ~= 0) && (stop_samples == 0)) % ONLY START time is entered    
    x3 = x2(start_samples:lenx2); % Store selected file sequence in a new vector x  
    
elseif ((start_samples == 0) && (stop_samples ~= 0)) % ONLY STOP time is entered     
    x3 = x2(1:stop_samples); % Store selected file sequence in a new vector x 
    
else % no time intervall is chosen    
    x3 = x2;    
    
end    

end